#include "stdafx.h"
#include "Mop.h"

vector<int> Q1,Q2,Q3,Pr,Tr,Tf;
int N, num_nodes, old_num_nodes;
CBitArray *T1, *T2;
CBitArray *X[7], *Xold[7];
CBitArray *S0[7], *S1[7];
CBitArray *R[3];
CBitArray *H[4],*G[3];
CBitArray *F[7];
int num_entr;
int FirstRun,FirstRun2;

int bIns=1;
int bExtOut=0;
int bMinOut=1;
int bAllXOut=1;
int bBegState=0;
int iSchType=0;
int bQOut=1;
char FNameMop[50];
char FNameEntr[50];
char FNameBegState[50];
ifstream f_entr;
ofstream f_out;

void MopTest()
{
	f_entr.clear();
	f_entr.open(FNameEntr);
	if (!f_entr) exit(0);
	f_entr>>num_entr;
	ReadDataFromFile(FNameMop);
	BitArrays_new();
	char fname[100];
	strcpy(fname,FNameMop);
	strcat(fname,".out");
	f_out.open(fname);
	if (!f_out) exit(0);
	FirstRun=FirstRun2=1;

	int n_iter = 0, max_iter = 2*num_nodes; //2*N;

	for(;;)
	{
		if (!SetX()) break;
		n_iter = 0;
		SetS0();
st3:	SetRHG();
		CalculateF();
		if (!bMinOut) WriteVars();
		Hasse();

		if (n_iter++ > max_iter)
		{
			WriteVars();
			f_out<<" : "<<n_iter+1<<"...\n\n";
			EndI();
			continue;	
		}
		if (CmpS0_S1())
		{
			if (bMinOut) WriteVars();
			f_out<<" : "<<n_iter<<"\n\n";
			continue;
		}

		SaveX();

		SwapS0_S1(); goto st3;
		break;
	}

	WriteQ();
	BitArrays_del();
	f_entr.close();
	f_out.close();
}

void SetUzel(int uzel, h_type h, g_type g)
{
	for(int i=0;i<3;i++) X[i]->SetBit(uzel,g>>i & 1);
	for(       ;i<7;i++) X[i]->SetBit(uzel,h>>(i-3) & 1);
}

void GetUzel(int uzel, h_type& h, g_type& g)
{
	int ig=0, ih=0;
	for(int i=0;i<3;i++) ig |= (F[i]->GetBit(uzel)<<i);
	for(       ;i<7;i++) ih |= (F[i]->GetBit(uzel)<<(i-3));
	g=(g_type)ig; h=(h_type)ih;
}

void GetUzelX(int uzel, h_type& h, g_type& g)
{
	int ig=0, ih=0;
	for(int i=0;i<3;i++) ig |= (X[i]->GetBit(uzel)<<i);
	for(       ;i<7;i++) ih |= (X[i]->GetBit(uzel)<<(i-3));
	g=(g_type)ig; h=(h_type)ih;
}


// add {
void SetUzelOld(int uzel, h_type h, g_type g)
{
	for(int i=0;i<3;i++) Xold[i]->SetBit(uzel,g>>i & 1);		
	for(       ;i<7;i++) Xold[i]->SetBit(uzel,h>>(i-3) & 1);
}

void GetUselX(int uzel, h_type& h, g_type& g)
{
	int ig=0, ih=0;
	for(int i=0;i<3;i++) ig |= (X[i]->GetBit(uzel)<<i);
	for(       ;i<7;i++) ih |= (X[i]->GetBit(uzel)<<(i-3));
	g=(g_type)ig; h=(h_type)ih;
}

void GetUselXold(int uzel, h_type& h, g_type& g)
{
	int ig=0, ih=0;
	for(int i=0;i<3;i++) ig |= (Xold[i]->GetBit(uzel)<<i);
	for(       ;i<7;i++) ih |= (Xold[i]->GetBit(uzel)<<(i-3));
	g=(g_type)ig; h=(h_type)ih;
}

void EndI()
{
	int i;
	h_type h1, h2;
	g_type g1, g2;

	for (i=num_entr+2; i<num_nodes; i++)
	{
		GetUselX(i,h1,g1);
		GetUselXold(i,h2,g2);
		if (h2<h1) {
			if (g1!=g2) SetUzel(i,h1,_X);}
		if (h2>h1) {
			if (g1!=g2) SetUzel(i,h2,_X);}
		if (h2==h1)
			{  if (g1!=g2) SetUzel(i,h2,_X);//else  SetUzel(i,h2,g2);
		}
			
	}
}

void SaveX()
{
	int i;
	h_type h;
	g_type g;

	for (i=num_entr+2; i<num_nodes; i++)
	{
		GetUselX(i,h,g);
		SetUzelOld(i,h,g);
	}
}
// add }

int MaxNodesValue(int node, h_type& h, g_type& g)
{
	int i,n=-1;
	for (i=0;i<N;i++)
		if( (Q1[i]-1)==node ) {n=i; break;}
	if (n==-1) return 0;

	h_type h1, h_max;
	g_type g1, g_max;
	GetUzelX(node,h_max,g_max);
	h1=C;h_max=h1;
	while ((Q1[n]-1)==node && n<N)
	{
		GetUzel(n,h1,g1);
		if (h1>h_max) {h_max=h1; g_max=g1;} else 
			if (h1==h_max)
				if (g1!=g_max) g_max=_X;
		n++;
	}
/*	int fx=1;
	while ( (Q1[n]-1)==node && n<N )
	{
		GetUzel(n,h1,g1);
		if (h1>h_max) {h_max=h1; g_max=g1; fx=1;}
		else
			if (h1==h_max)
				if (g1==_X) {g_max=_X; fx=1;}
				else
					if (g1!=g_max && g_max!=_X && g_max!=_Z && g1!=Z)
						fx=0;
		n++;
	}
	if (!fx) g_max=_X;*/
	h=h_max; g=g_max;
	return 1;
}

int SetX()
{
	static int f=1;
	if (FirstRun) f=1;
	SetUzel(0,D,_0); // 
	SetUzel(1,D,_1); // 

	h_type h=C;
	g_type g=_X;
	char s[5];

	if (bBegState)
	{
		if (!f) return 0;
		ifstream f_in(FNameBegState);
		if (!f_in) exit(0);

		for(int i=2;i<old_num_nodes;i++)
		{
			f_in>>s;
			if (!f_in) return 0;
			ConvKod1(s,h,g);
			SetUzel(i,h,g);
		}
		for( ;i<num_nodes;i++)
			SetUzel(i,C,_X);
		f=0;
		FirstRun=0;
		return 1;
	}

	for(int i=2;i<num_entr+2;i++)
	{
		f_entr>>s;
		if (!f_entr) return 0;
		ConvKod1(s,h,g);
		SetUzel(i,h,g);     // 
	}

	//  
	if (f)
		for(i=num_entr+2;i<num_nodes;i++)
			SetUzel(i,C,_X);
	else
		for(i=num_entr+2;i<num_nodes;i++)
		{
			GetUzelX(i,h,g);
			SetUzel (i,C,g);
		}
	f=0;

	static cnt=1;
	if (FirstRun) cnt=1;
	if (bExtOut) 
		f_out<<"========\n  "<<cnt++<<"\n========\n";
	else
		f_out<<"\n  "<<cnt++<<"\n--------\n\n";

	FirstRun=0;
	return 1;
}

void SetS0()
{
	int i,r;

	for (i=0;i<N;i++)
		for(r=0;r<7;r++)
			S0[r]->SetBit(i,X[r]->GetBit(Q1[i]-1));
}

void SetS1()
{
	int i,r;

	for (i=0;i<N;i++)
		for(r=0;r<7;r++)
			S1[r]->SetBit(i,X[r]->GetBit(Q1[i]-1));
}

void SetRHG()
{
	int i,r;

	for (i=0;i<N;i++)
		for(r=0;r<3;r++)
			R[r]->SetBit(i,X[r]->GetBit(Q2[i]-1));

	for (i=0;i<N;i++)
		for(r=0;r<3;r++)
			G[r]->SetBit(i,X[r]->GetBit(Q3[i]-1));

	for (i=0;i<N;i++)
		for(r=3;r<7;r++)
			H[r-3]->SetBit(i,X[r]->GetBit(Q3[i]-1));
}

void CalculateF()
{
  int i;
  if (bIns || iSchType==3) {
	for (i=0;i<3;i++)
	*F[i]= ( (*T1 & *T2 & *R[1] & *G[i]) | (*T1 & (~*T2) & *R[0] & *G[i]) | ((~*T1) & *T2 & *R[1] & *G[i]) | ((~*T1) & (~*T2) & *G[i]) );

	*F[3]= ( (*T1 & *T2 & *R[1] & *H[0]) | (*T1 & (~*T2) & *R[0] & *H[0]) | ((~*T1) & *T2 & *R[1] & *H[1]) | ((~*T1) & (~*T2) & *H[1]) );
	*F[4]= ( (*T1 & *T2 & *R[1] & *H[1]) | (*T1 & (~*T2) & *R[0] & *H[1]) | ((~*T1) & *T2 & *R[1] & *H[2]) | ((~*T1) & (~*T2) & *H[2]) );
	*F[5]= ( (*T1 & *T2 & *R[1] & *H[2]) | (*T1 & (~*T2) & *R[0] & *H[2]) | ((~*T1) & *T2 & *R[1] & *H[3]) | ((~*T1) & (~*T2) & *H[3]) );
	*F[6]= ( (*T1 & *T2 & *R[1] & *H[3]) | (*T1 & (~*T2) & *R[0] & *H[3]) );
  }
  else
  switch (iSchType) {
  case 0: // -
	for (i=0;i<3;i++)
	*F[i]= ( (*G[i] & *T1 & (~(*R[1]^*T2))) );

	*F[3]= ( *T1 & *H[0] & (~(*R[1]^*T2)) );
	*F[4]= ( (*T1 & *H[1] & (~(*R[1]^*T2))) );
	*F[5]= ( (*T1 & *H[2] & (~(*R[1]^*T2))) );
	*F[6]= ( (*T1 & *H[3] & (~(*R[1]^*T2))) );
  break;

  case 1: // -  .,   . 
	for (i=0;i<3;i++)
	*F[i]= ( (*G[i] & *T1 & (~(*R[1]^*T2))) | (*G[i] & (~*T1)) );

	*F[3]= ( *T1 & *H[0] & (~(*R[1]^*T2)) );
	*F[4]= ( (*T1 & *H[1] & (~(*R[1]^*T2))) | ((~*T1) & *H[1] & (~*H[0])) | ((~*T1) & *H[0]) );
	*F[5]= ( (*T1 & *H[2] & (~(*R[1]^*T2))) | ((~*T1) & *H[2] & (~*H[0])));
	*F[6]= ( (*T1 & *H[3] & (~(*R[1]^*T2))) | ((~*T1) & *H[3] & (~*H[0])));
  break;

  case 2: // -  .,   . 
	for (i=0;i<3;i++)
	*F[i]= ( (*G[i] & *T1 & (~(*R[1]^*T2))) | (*G[i] & (~*T1) & (~*T2)) );

	*F[3]= ( *T1 & *H[0] & (~(*R[1]^*T2)) );
	*F[4]= ( (*T1 & *H[1] & (~(*R[1]^*T2))) | ((~*T1) & (~*T2) & *H[1]) ); // ???
	*F[5]= ( (*T1 & *H[2] & (~(*R[1]^*T2))) | ((~*T1) & (~*T2) & *H[2]) );
	*F[6]= ( (*T1 & *H[3] & (~(*R[1]^*T2))) | ((~*T1) & (~*T2) & *H[3]) );
  break;

  default:
    exit(0);
  }
}

void SwapS0_S1()
{
	CBitArray *tmp;
	for(int r=0;r<7;r++)
	{
		tmp=S1[r]; S1[r]=S0[r]; S0[r]=tmp;
	}
}

int CmpS0_S1()
{
	int i,r,rez=1;
	for (i=0;i<N;i++)
		for(r=0;r<7;r++)
			if (S0[r]->GetBit(i)!=S1[r]->GetBit(i)) rez=0;
	return rez;
}

void Hasse()
{
	for (int i=num_entr+2;i<num_nodes;i++)
	{
		h_type h;
		g_type g;
		
		if (MaxNodesValue(i,h,g))
			SetUzel(i,h,g);
	}
	SetS1();
}

void BitArrays_new()
{
	for(int i=0;i<7;i++) X[i]=new CBitArray(num_nodes);
	for(i=0;i<7;i++) Xold[i]=new CBitArray(num_nodes);
	for(i=0;i<7;i++) S0[i]=new CBitArray(N);
	for(i=0;i<7;i++) S1[i]=new CBitArray(N);
	for(i=0;i<3;i++) R[i]=new CBitArray(N);
	for(i=0;i<4;i++) H[i]=new CBitArray(N);
	for(i=0;i<3;i++) G[i]=new CBitArray(N);
	for(i=0;i<7;i++) F[i]=new CBitArray(N);
}

void BitArrays_del()
{
	for(int i=0;i<7;i++) delete X[i];
	for(i=0;i<7;i++) delete Xold[i];
	for(i=0;i<7;i++) delete S0[i];
	for(i=0;i<7;i++) delete S1[i];
	for(i=0;i<3;i++) delete R[i];
	for(i=0;i<4;i++) delete H[i];
	for(i=0;i<3;i++) delete G[i];
	for(i=0;i<7;i++) delete F[i];

}

extern vector<int> tmp1,tmp2;

void InsertTrans()
{
	int i,j,k,qs,cnt_add=0,cur_node=num_nodes+1, cur_numt=N/2+1;

	for(i=0;i<Q1.size();i++)
	{
		if (Pr[i]<2) continue;

		int q1=Q1[i],q2=Q2[i],q3=Q3[i],pr=Pr[i],tr=Tr[i],t1=tmp1[i],t2=tmp2[i];
    int ns1, ns2, f, tq2 = (t1==1 && t2==1)? 2:1;

//----------------------------------------------------------------------
		for(j=0;j<Pr[i]-1;j++)
		{
			int val = ((j==0)? Q1[i]:cur_node-1);
			Q1.insert(Q1.end(), val );
			Q2.insert(Q2.end(), cur_node );
			Q3.insert(Q3.end(), cur_node+1 );
			Tr.insert(Tr.end(), cur_numt );
			Pr.insert(Pr.end(), 1 );
			tmp1.insert(tmp1.end(), t1 );
			tmp2.insert(tmp2.end(), t2 );
      Tf.insert(Tf.end(), 1 );

			Q1.insert(Q1.end(), cur_node+1 );
			Q2.insert(Q2.end(), cur_node );
			Q3.insert(Q3.end(), val );
			Tr.insert(Tr.end(), cur_numt );
			Pr.insert(Pr.end(), 1 );
			tmp1.insert(tmp1.end(), t1 );
			tmp2.insert(tmp2.end(), t2 );
      Tf.insert(Tf.end(), 1 );
      cnt_add+=2; cur_numt++;

      int val2 = ((j==Pr[i]-2)? Q2[i]:cur_node+2);
      Q1.insert(Q1.end(), cur_node );
			Q2.insert(Q2.end(), tq2 );
			Q3.insert(Q3.end(), val2 );
			Tr.insert(Tr.end(), cur_numt );
			Pr.insert(Pr.end(), 1 );
			tmp1.insert(tmp1.end(), t1 );
			tmp2.insert(tmp2.end(), t2 );
      Tf.insert(Tf.end(), 1 );

      Q1.insert(Q1.end(), val2 );
			Q2.insert(Q2.end(), tq2 );
			Q3.insert(Q3.end(), cur_node );
			Tr.insert(Tr.end(), cur_numt );
			Pr.insert(Pr.end(), 1 );
			tmp1.insert(tmp1.end(), t1 );
			tmp2.insert(tmp2.end(), t2 );
      Tf.insert(Tf.end(), 1 );

      cnt_add+=2; cur_numt++;
			cur_node+=2; 
		}
    ns1 = cur_node-1;
//----------------------------------------------------------------------
    for(j=0;j<Pr[i]-1;j++)
		{
			int val = ((j==0)? Q3[i]:cur_node-1);
			Q1.insert(Q1.end(), val );
			Q2.insert(Q2.end(), cur_node );
			Q3.insert(Q3.end(), cur_node+1 );
			Tr.insert(Tr.end(), cur_numt );
			Pr.insert(Pr.end(), 1 );
			tmp1.insert(tmp1.end(), t1 );
			tmp2.insert(tmp2.end(), t2 );
      Tf.insert(Tf.end(), 1 );

			Q1.insert(Q1.end(), cur_node+1 );
			Q2.insert(Q2.end(), cur_node );
			Q3.insert(Q3.end(), val );
			Tr.insert(Tr.end(), cur_numt );
			Pr.insert(Pr.end(), 1 );
			tmp1.insert(tmp1.end(), t1 );
			tmp2.insert(tmp2.end(), t2 );
      Tf.insert(Tf.end(), 1 );
      cnt_add+=2; cur_numt++;

      int val2 = ((j==Pr[i]-2)? Q2[i]:cur_node+2);
      Q1.insert(Q1.end(), cur_node );
			Q2.insert(Q2.end(), tq2 );
			Q3.insert(Q3.end(), val2 );
			Tr.insert(Tr.end(), cur_numt );
			Pr.insert(Pr.end(), 1 );
			tmp1.insert(tmp1.end(), t1 );
			tmp2.insert(tmp2.end(), t2 );
      Tf.insert(Tf.end(), 1 );

      Q1.insert(Q1.end(), val2 );
			Q2.insert(Q2.end(), tq2 );
			Q3.insert(Q3.end(), cur_node );
			Tr.insert(Tr.end(), cur_numt );
			Pr.insert(Pr.end(), 1 );
			tmp1.insert(tmp1.end(), t1 );
			tmp2.insert(tmp2.end(), t2 );
      Tf.insert(Tf.end(), 1 );

      cnt_add+=2; cur_numt++;
			cur_node+=2; 
		}
    ns2 = cur_node-1;
//----------------------------------------------------------------------

		for(k=0, qs=Q1.size(); k<qs; k++)
			if (q1==Q1[k] && q2==Q2[k] && q3==Q3[k] && pr==Pr[k] && tr==Tr[k] && t1==tmp1[k] && t2==tmp2[k])
			{
				Q1.erase(Q1.begin()+k);
				Q2.erase(Q2.begin()+k);
				Q3.erase(Q3.begin()+k);
				Tr.erase(Tr.begin()+k);
				Pr.erase(Pr.begin()+k);
				tmp1.erase(tmp1.begin()+k);
				tmp2.erase(tmp2.begin()+k);
        Tf.erase(Tf.begin()+k);
				break;
			}
		Q1.insert(Q1.end(), ns1 );
		Q2.insert(Q2.end(), q2 );
		Q3.insert(Q3.end(), ns2 );
		Tr.insert(Tr.end(), tr );
		Pr.insert(Pr.end(), 1 );
		tmp1.insert(tmp1.end(), t1 );
		tmp2.insert(tmp2.end(), t2 );
    Tf.insert(Tf.end(), 0 );

		for(k=0, qs=Q1.size(), f=0; k<qs; k++)
			if (q3==Q1[k] && q2==Q2[k] && q1==Q3[k] && pr==Pr[k] && tr==Tr[k] && t1==tmp1[k] && t2==tmp2[k])
			{
				Q1.erase(Q1.begin()+k);
				Q2.erase(Q2.begin()+k);
				Q3.erase(Q3.begin()+k);
				Tr.erase(Tr.begin()+k);
				Pr.erase(Pr.begin()+k);
				tmp1.erase(tmp1.begin()+k);
				tmp2.erase(tmp2.begin()+k);
        Tf.erase(Tf.begin()+k);
				f=1; break;
			}
		if (f)
		{
		  Q1.insert(Q1.end(), ns2 );
		  Q2.insert(Q2.end(), q2 );
		  Q3.insert(Q3.end(), ns1 );
		  Tr.insert(Tr.end(), tr );
		  Pr.insert(Pr.end(), 1 );
		  tmp1.insert(tmp1.end(), t1 );
		  tmp2.insert(tmp2.end(), t2 );
      Tf.insert(Tf.end(), 0 );
		}
	  i=0;
	}
	N+=cnt_add;
	num_nodes = cur_node-1;
}

void SortTrans()
{
  int i,j,f,t, n = Q1.size();

  if ( n!=Q2.size() || n!=Q3.size() || n!=Tr.size() || n!=Pr.size() || n!=tmp1.size() || n!=tmp2.size()  || n!=Tf.size())
    exit(0);

	for(i=n-2,f=1; i>=0 && f; i--)
    for(j=0,f=0; j<=i     ; j++)
      if (Q1[j]>Q1[j+1])
      {
        t=Q1[j]; Q1[j]=Q1[j+1]; Q1[j+1]=t;
        t=Q2[j]; Q2[j]=Q2[j+1]; Q2[j+1]=t;
        t=Q3[j]; Q3[j]=Q3[j+1]; Q3[j+1]=t;
        t=Tr[j]; Tr[j]=Tr[j+1]; Tr[j+1]=t;
        t=Pr[j]; Pr[j]=Pr[j+1]; Pr[j+1]=t;
        t=tmp1[j]; tmp1[j]=tmp1[j+1]; tmp1[j+1]=t;
        t=tmp2[j]; tmp2[j]=tmp2[j+1]; tmp2[j+1]=t;
        t=Tf[j]; Tf[j]=Tf[j+1]; Tf[j+1]=t;
        f=1;
      }
}

